--------------------------------------------------------------------------------
-- Generate spreadsheet using stored procedure
--------------------------------------------------------------------------------

call sql2excel ('select * from employee', ?) @


--------------------------------------------------------------------------------
-- Generate spreadsheet using UDF
--------------------------------------------------------------------------------

values sql2excel ('select * from employee') @


--------------------------------------------------------------------------------
-- Display spreadsheet using Excel
--------------------------------------------------------------------------------

export to 'c:\temp\sql2excel.del' of del lobs to 'c:\temp' lobfile 'sql2excel' 
       modified by lobsinfile 
   values sql2excel ('select * from employee') @
!copy /y c:\temp\sql2excel.001 c:\temp\sql2excel.xml @
!"c:\program files\microsoft office\office11\excel.exe" c:\temp\sql2excel.xml @


--------------------------------------------------------------------------------
-- Display spreadsheet w/ pivot table
--------------------------------------------------------------------------------

export to 'c:\temp\sql2excel.del' of del lobs to 'c:\temp' lobfile 'sql2excel' 
       modified by lobsinfile 
  values sql2excel ('select * from employee', 
  '<Names><NamedRange ss:Name="PTData" ss:RefersTo="Sheet1!R1C1:OFFSET(sheet1!R1C1,COUNTA(sheet1!C1)- 1,COUNTA(Sheet1!R1)-1)"></NamedRange></Names>
   <Worksheet ss:Name="Pivot Sheet1">
     <PivotTable xmlns="urn:schemas-microsoft-com:office:excel">
     <Name>Pivot Sheet1</Name><Location>R1C1:R1C1</Location>
      <PivotField>
       <Name>SEX</Name><Orientation>Page</Orientation><Position>1</Position> 
       <PivotItem><Name>F</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>WORKDEPT</Name><Orientation>Row</Orientation><Position>1</Position> 
       <PivotItem><Name>A00</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>JOB</Name><Orientation>Column</Orientation><Position>1</Position> 
       <PivotItem><Name>PRES</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>Sum of SALARY</Name> 
       <ParentField>SALARY</ParentField><Orientation>Data</Orientation><Position>1</Position>
       <Function>Sum</Function>
      </PivotField>
   
      <PivotField><Name>EMPNO</Name></PivotField>
      <PivotField><Name>FIRSTNME</Name></PivotField>
      <PivotField><Name>MIDINIT</Name></PivotField>
      <PivotField><Name>LASTNAME</Name></PivotField>
      <PivotField><Name>PHONENO</Name></PivotField>
      <PivotField><Name>HIREDATE</Name></PivotField>
      <PivotField><Name>EDLEVEL</Name></PivotField>
      <PivotField><Name>BIRTHDATE</Name></PivotField>
      <PivotField><Name>SALARY</Name></PivotField>
      <PivotField><Name>BONUS</Name></PivotField>
      <PivotField><Name>COMM</Name></PivotField> 

      <PTLineItems><Orientation>Column</Orientation><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>
      <PTLineItems><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>

      <PTSource><RefreshOnFileOpen></RefreshOnFileOpen>
   	<ConsolidationReference>
   	 <FileName>[sql2excel.xml]Sheet1</FileName>
   	 <Name>PTData</Name>
   	</ConsolidationReference>
      </PTSource>
     </PivotTable>
   </Worksheet>') @
!copy /y c:\temp\sql2excel.001 c:\temp\sql2excel.xml @
!"c:\program files\microsoft office\office11\excel.exe" c:\temp\sql2excel.xml @


--------------------------------------------------------------------------------
-- Send dummy email
--------------------------------------------------------------------------------

values sendmail ('relay.us.ibm.com', 'reinwald@almaden.ibm.com', 'Berthold Reinwald', 
                 'reinwald@almaden.ibm.com', 
                 'testing', 'this is the body', 
                 cast('attachment' as clob(32M)), cast('attachment name' as varchar(255)), 
                 cast(NULL as clob(4)), cast(NULL as varchar(4)), cast (NULL as clob(4)), 
                 cast(NULL as varchar(4))) @


--------------------------------------------------------------------------------
-- Send Spreadsheet as email
--------------------------------------------------------------------------------

call sendexcel('relay.us.ibm.com', 'reinwald@almaden.ibm.com', 'Berthold Reinwald', 
               'reinwald@almaden.ibm.com',
               'Generated email for Excel Testing (Employee Spreadsheet)', 
               'The attachment contains your requested Employee report.',
               'select * from employee', 'employee_list.xls') @


--------------------------------------------------------------------------------
-- Send Spreadsheet w/ pivot table as email
--------------------------------------------------------------------------------

call sendexcel('relay.us.ibm.com', 'reinwald@almaden.ibm.com', 'Berthold Reinwald', 
               'reinwald@almaden.ibm.com',
               'Generated email for Excel Testing (Employee Spreadsheet)', 
               'The attachment contains your requested Employee report.',
               'select * from employee', 
  '<Names><NamedRange ss:Name="PTData" ss:RefersTo="Sheet1!R1C1:OFFSET(sheet1!R1C1,COUNTA(sheet1!C1)- 1,COUNTA(Sheet1!R1)-1)"></NamedRange></Names>
   <Worksheet ss:Name="Pivot Sheet1">
     <PivotTable xmlns="urn:schemas-microsoft-com:office:excel">
     <Name>Pivot Sheet1</Name><Location>R1C1:R1C1</Location>
      <PivotField>
       <Name>SEX</Name><Orientation>Page</Orientation><Position>1</Position> 
       <PivotItem><Name>F</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>WORKDEPT</Name><Orientation>Row</Orientation><Position>1</Position> 
       <PivotItem><Name>A00</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>JOB</Name><Orientation>Column</Orientation><Position>1</Position> 
       <PivotItem><Name>PRES</Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>Sum of SALARY</Name> 
       <ParentField>SALARY</ParentField><Orientation>Data</Orientation><Position>1</Position>
       <Function>Sum</Function>
      </PivotField>
   
      <PivotField><Name>EMPNO</Name></PivotField>
      <PivotField><Name>FIRSTNME</Name></PivotField>
      <PivotField><Name>MIDINIT</Name></PivotField>
      <PivotField><Name>LASTNAME</Name></PivotField>
      <PivotField><Name>PHONENO</Name></PivotField>
      <PivotField><Name>HIREDATE</Name></PivotField>
      <PivotField><Name>EDLEVEL</Name></PivotField>
      <PivotField><Name>BIRTHDATE</Name></PivotField>
      <PivotField><Name>SALARY</Name></PivotField>
      <PivotField><Name>BONUS</Name></PivotField>
      <PivotField><Name>COMM</Name></PivotField> 

      <PTLineItems><Orientation>Column</Orientation><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>
      <PTLineItems><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>

      <PTSource><RefreshOnFileOpen></RefreshOnFileOpen>
   	<ConsolidationReference>
   	 <FileName>[sql2excel.xml]Sheet1</FileName>
   	 <Name>PTData</Name>
   	</ConsolidationReference>
      </PTSource>
     </PivotTable>
   </Worksheet>',
              'sql2excel.xml') @


--------------------------------------------------------------------------------
--  Generate spreadsheet for Customers table
--------------------------------------------------------------------------------

export to 'c:\temp\sql2excel.del' of del lobs to 'c:\temp' lobfile 'sql2excel' 
       modified by lobsinfile 

   values sql2excel ('select custid, fname, lname, email, workphone, homephone, 
                          gender, marital_status, 
                          income_range, zipcode, residence, birthdate, smoker 
                   from stars.cust', 
                   cast(null as varchar(32000)))@

!copy /y c:\temp\sql2excel.001 c:\temp\sql2excel.xml@
!"c:\program files\microsoft office\office11\excel.exe" c:\temp\sql2excel.xml@


--------------------------------------------------------------------------------
-- Generate spreadhseet w/ pivottable for Sales on Location and Product dimension
--------------------------------------------------------------------------------

export to 'c:\temp\sql2excelPT.del' of del lobs to 'c:\temp' lobfile 'sql2excelPT' 
       modified by lobsinfile 

 values sql2excel (
     'SELECT loc.country, loc.state, loc.city, country_population, state_population, 
             city_population, year(t.shipdate) as year, month(t.shipdate) as month, 
               l.linename, pg.pgname,
              (ti.qty* ti.price) AS sales
      FROM   stars.transitem AS ti, stars.trans AS t,
             stars.loc AS loc, stars.product as p, stars.pgroup AS pg, 
             stars.prodline AS l
      WHERE  ti.transid = t.transid
         AND ti.prodid = p.prodid
         AND p.pgid = pg.pgid 
         AND pg.lineid = l.lineid
         AND t.locid = loc.locid', 
   '<Names><NamedRange ss:Name="PTData" ss:RefersTo="Sheet1!R1C1:OFFSET(sheet1!R1C1,COUNTA(sheet1!C1)- 1,COUNTA(Sheet1!R1)-1)"></NamedRange></Names>
   <Worksheet ss:Name="Pivot Sheet1">
     <PivotTable xmlns="urn:schemas-microsoft-com:office:excel">
     <Name>Pivot Sheet1</Name><Location>R1C1:R1C1</Location>
   
      <PivotField>
       <Name>COUNTRY</Name><Orientation>Page</Orientation><Position>1</Position> 
       <PivotItem><Name></Name></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>STATE</Name><Orientation>Row</Orientation><Position>1</Position> 
       <AutoSortOrder>Ascending</AutoSortOrder><PivotItem><Name></Name><HideDetail/></PivotItem>
      </PivotField>

      <PivotField>
       <Name>CITY</Name><Orientation>Row</Orientation><Position>2</Position> 
       <AutoSortOrder>Ascending</AutoSortOrder><PivotItem><Name></Name><HideDetail/></PivotItem>
      </PivotField>

      <PivotField>
       <Name>LINENAME</Name><Orientation>Column</Orientation><Position>1</Position> 
       <AutoSortOrder>Ascending</AutoSortOrder><PivotItem><Name></Name><HideDetail/></PivotItem>
      </PivotField>
   
      <PivotField>
       <Name>Sum of SALES</Name> 
       <ParentField>SALES</ParentField><Orientation>Data</Orientation><Position>1</Position>
       <Function>Sum</Function>
      </PivotField>
   
      <PivotField><Name>PGNAME</Name></PivotField>
      <PivotField><Name>YEAR</Name></PivotField>
      <PivotField><Name>MONTH</Name></PivotField>
      <PivotField><Name>SALES</Name></PivotField>
      <PivotField><Name>country_population</Name></PivotField>
      <PivotField><Name>state_population</Name></PivotField>
      <PivotField><Name>city_population</Name></PivotField>

      <PTLineItems><Orientation>Column</Orientation><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>
      <PTLineItems><PTLineItem><Item>0</Item></PTLineItem></PTLineItems>

      <PTSource><RefreshOnFileOpen></RefreshOnFileOpen>
   	<ConsolidationReference>
   	 <FileName>[sql2excelPT.xml]Sheet1</FileName>
   	 <Name>PTData</Name>
   	</ConsolidationReference>
      </PTSource>
     </PivotTable>
   </Worksheet>')@
!copy /y c:\temp\sql2excelPT.001 c:\temp\sql2excelPT.xml@
!"c:\program files\microsoft office\office11\excel.exe" c:\temp\sql2excelPT.xml@
